<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcMovable Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcMovable Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcMovable" --><!-- doxytag: inherits="iBase" -->
<p>Control moving an <a class="el" href="structiPcMesh.html" title="This is a property class holding the representation of a mesh.">iPcMesh</a>.  
 <a href="structiPcMovable.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="move_8h_source.html">propclass/move.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcMovable:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcMovable.png" usemap="#iPcMovable_map" alt=""/>
  <map id="iPcMovable_map" name="iPcMovable_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,79,24"/>
</map>
 </div></div>

<p><a href="structiPcMovable-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMovable.html#a1fbe42e59d654568f2b5328142e5a318">AddConstraint</a> (<a class="el" href="structiPcMovableConstraint.html">iPcMovableConstraint</a> *constraint)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a constraint.  <a href="#a1fbe42e59d654568f2b5328142e5a318"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiPcMesh.html">iPcMesh</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMovable.html#ac6f7966e64d72a1c18fb4b10a2458d69">GetMesh</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the current mesh on which we're working.  <a href="#ac6f7966e64d72a1c18fb4b10a2458d69"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMovable.html#a3e67a9b22dd7d7ce119838dc51b1aa66">Move</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;pos)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Move object while checking constraints.  <a href="#a3e67a9b22dd7d7ce119838dc51b1aa66"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMovable.html#a57a22a7e71cfa9e9be17b7b7e7573e7d">Move</a> (const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;relpos)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Relative move.  <a href="#a57a22a7e71cfa9e9be17b7b7e7573e7d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMovable.html#ab4833e9015462536c3c28570c7492bf5">RemoveAllConstraints</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove all constraints.  <a href="#ab4833e9015462536c3c28570c7492bf5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMovable.html#acbe3b6d22eb78e57425b7737389c4173">RemoveConstraint</a> (<a class="el" href="structiPcMovableConstraint.html">iPcMovableConstraint</a> *constraint)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a constraint.  <a href="#acbe3b6d22eb78e57425b7737389c4173"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcMovable.html#abb4cbea5c773b05560dcef3b391c8da3">SetMesh</a> (<a class="el" href="structiPcMesh.html">iPcMesh</a> *mesh)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set mesh to move.  <a href="#abb4cbea5c773b05560dcef3b391c8da3"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Control moving an <a class="el" href="structiPcMesh.html" title="This is a property class holding the representation of a mesh.">iPcMesh</a>. </p>

<p>Definition at line <a class="el" href="move_8h_source.html#l00044">44</a> of file <a class="el" href="move_8h_source.html">move.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a1fbe42e59d654568f2b5328142e5a318"></a><!-- doxytag: member="iPcMovable::AddConstraint" ref="a1fbe42e59d654568f2b5328142e5a318" args="(iPcMovableConstraint *constraint)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMovable.html#a1fbe42e59d654568f2b5328142e5a318">iPcMovable::AddConstraint</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcMovableConstraint.html">iPcMovableConstraint</a> *&#160;</td>
          <td class="paramname"><em>constraint</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a constraint. </p>

</div>
</div>
<a class="anchor" id="ac6f7966e64d72a1c18fb4b10a2458d69"></a><!-- doxytag: member="iPcMovable::GetMesh" ref="ac6f7966e64d72a1c18fb4b10a2458d69" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiPcMesh.html">iPcMesh</a>* <a class="el" href="structiPcMovable.html#ac6f7966e64d72a1c18fb4b10a2458d69">iPcMovable::GetMesh</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the current mesh on which we're working. </p>

</div>
</div>
<a class="anchor" id="a3e67a9b22dd7d7ce119838dc51b1aa66"></a><!-- doxytag: member="iPcMovable::Move" ref="a3e67a9b22dd7d7ce119838dc51b1aa66" args="(iSector *sector, const csVector3 &amp;pos)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual int <a class="el" href="structiPcMovable.html#a3e67a9b22dd7d7ce119838dc51b1aa66">iPcMovable::Move</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td>
          <td class="paramname"><em>sector</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Move object while checking constraints. </p>
<p>This routine will ignore the previous position and will just check if it is possible to move to the given position. Returns: </p>
<ul>
<li>
CEL_MOVE_FAIL: if no movement was possible. </li>
<li>
CEL_MOVE_SUCCEED: if movement was possible. </li>
</ul>

</div>
</div>
<a class="anchor" id="a57a22a7e71cfa9e9be17b7b7e7573e7d"></a><!-- doxytag: member="iPcMovable::Move" ref="a57a22a7e71cfa9e9be17b7b7e7573e7d" args="(const csVector3 &amp;relpos)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual int <a class="el" href="structiPcMovable.html#a3e67a9b22dd7d7ce119838dc51b1aa66">iPcMovable::Move</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>relpos</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Relative move. </p>
<p>Check constraints too. This function will correctly update the current sector if a portal is traversed. Returns: </p>
<ul>
<li>
CEL_MOVE_FAIL: if no movement was possible. </li>
<li>
CEL_MOVE_SUCCEED: if movement was possible. </li>
<li>
CEL_MOVE_PARTIAL: if object could move partially. </li>
</ul>

</div>
</div>
<a class="anchor" id="ab4833e9015462536c3c28570c7492bf5"></a><!-- doxytag: member="iPcMovable::RemoveAllConstraints" ref="ab4833e9015462536c3c28570c7492bf5" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMovable.html#ab4833e9015462536c3c28570c7492bf5">iPcMovable::RemoveAllConstraints</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove all constraints. </p>

</div>
</div>
<a class="anchor" id="acbe3b6d22eb78e57425b7737389c4173"></a><!-- doxytag: member="iPcMovable::RemoveConstraint" ref="acbe3b6d22eb78e57425b7737389c4173" args="(iPcMovableConstraint *constraint)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMovable.html#acbe3b6d22eb78e57425b7737389c4173">iPcMovable::RemoveConstraint</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcMovableConstraint.html">iPcMovableConstraint</a> *&#160;</td>
          <td class="paramname"><em>constraint</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a constraint. </p>

</div>
</div>
<a class="anchor" id="abb4cbea5c773b05560dcef3b391c8da3"></a><!-- doxytag: member="iPcMovable::SetMesh" ref="abb4cbea5c773b05560dcef3b391c8da3" args="(iPcMesh *mesh)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcMovable.html#abb4cbea5c773b05560dcef3b391c8da3">iPcMovable::SetMesh</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiPcMesh.html">iPcMesh</a> *&#160;</td>
          <td class="paramname"><em>mesh</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set mesh to move. </p>
<p>If not set a default mesh will be found from the parent entity. </p>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="move_8h_source.html">move.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
